%define		crates_ver	0.5.0
%define 	module	adblock

Summary:	Brave's adblock library in Python
Name:		python3-%{module}
Version:	0.5.0
Release:	1
License:	MIT or Apache v2.0
Group:		Libraries/Python
Source0:	https://files.pythonhosted.org/packages/source/a/adblock/%{module}-%{version}.tar.gz
# Source0-md5:	1183beaf1e82e16fae7a797e57de013f
# ./create-crates.sh
Source1:	%{name}-crates-%{crates_ver}.tar.xz
# Source1-md5:	da4deea3a344332cf913d942843e8ee7
URL:		https://github.com/ArniDagur/python-adblock
BuildRequires:	cargo
BuildRequires:	maturin >= 0.10
BuildRequires:	python3-devel >= 1:3.6
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 2.004
BuildRequires:	rust >= 1.45
ExclusiveArch:	%{rust_arches}
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%ifarch x32
%define		cargo_outdir	target/x86_64-unknown-linux-gnux32
%else
%define		cargo_outdir	target
%endif

%description
Python wrapper for Brave's adblocking library, which is written in
Rust.

%prep
%setup -q -n %{module}-%{version} -a1

%{__mv} %{module}-%{crates_ver}/* .
sed -i -e 's/@@VERSION@@/%{version}/' Cargo.lock

# use our offline registry
export CARGO_HOME="$(pwd)/.cargo"

mkdir -p "$CARGO_HOME"
cat >.cargo/config <<EOF
[source.crates-io]
registry = 'https://github.com/rust-lang/crates.io-index'
replace-with = 'vendored-sources'

[source.vendored-sources]
directory = '$PWD/vendor'
EOF

%build
export CARGO_HOME="$(pwd)/.cargo"
export CARGO_NET_OFFLINE=true
export CARGO_TERM_VERBOSE=true
%{?__jobs:export CARGO_BUILD_JOBS="%{__jobs}"}
export RUSTFLAGS="%{rpmrustflags}"
%ifarch %{ix86}
export RUSTFLAGS="$RUSTFLAGS -C opt-level=1"
%endif
/usr/bin/maturin build --release --no-sdist \
%ifarch x32
	--target x86_64-unknown-linux-gnux32
%endif

%install
rm -rf $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT%{py3_sitedir}
cp -p %{cargo_outdir}/release/libadblock.so $RPM_BUILD_ROOT%{py3_sitedir}/%{module}.so

%clean
rm -rf $RPM_BUILD_ROOT

%files -n python3-%{module}
%defattr(644,root,root,755)
%doc CHANGELOG.md README.md
%attr(755,root,root) %{py3_sitedir}/%{module}.so
%changelog
* Sun Jun 27 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python3-adblock.git;a=log;h=master

* Sun Jun 27 2021 Jan Palus <atler@pld-linux.org> 9250408
- up to 0.5.0

* Wed Apr 14 2021 Jan Palus <atler@pld-linux.org> f679bd2
- reduce opt-level on %{ix86} to fix build

* Wed Apr 14 2021 Jan Palus <atler@pld-linux.org> 48c8699
- define CARGO_BUILD_JOBS

* Wed Apr 14 2021 Jan Palus <atler@pld-linux.org> 2a8ce8c
- fix install on x32

* Wed Apr 14 2021 Jan Palus <atler@pld-linux.org> 11e4f1c
- new

